import java.io.*;
import java.util.*;
import java.text.*;

public class checkstacks
{
    public BufferedReader br;
    public PrintStream ps;

    public String toString()
    {
        return "checkstacks";
    }

    public String pips = "123456789TJQK";
    public String suits = "HCDS";

    public int value( String card )
    {
        int p = pips.indexOf( card.charAt(0) );
        int s = suits.indexOf( card.charAt(1) );
        return s*13+p;
    }

    public int n;
    public Integer deck[];

    public String validate( BufferedReader b, String which ) throws Exception
    {
        String result = "???";
        String caseno = b.readLine().trim();
        String tokens[] = b.readLine().trim().split( "\\s+" );

        if( !caseno.equals( which ) )
        {
            result = "failure: case number not right";
        }
        else if( tokens.length==1 )
        {
            result = tokens[0];
            //System.out.println( "Case " + caseno + " " + which + " sez " + tokens[0] );
        }
        else
        {
            result = "success";
            LinkedList<Integer> d = new LinkedList<Integer>();
            for( int j=0; j<deck.length; j++ ) d.add( deck[j] );
            Stack<Integer> s1 = new Stack<Integer>();
            Stack<Integer> s2 = new Stack<Integer>();
            int discard = -1;
            for( int i=0; i<n+n; i++ )
            {
                if( i>0 )
                {
                    tokens = b.readLine().trim().split( "\\s+" );
                }

                int st = Integer.parseInt( tokens[1] );

                if( st!=1 && st!=2 )
                {
                    result = "failure: st=" + tokens[1];
                    break;
                }

                if( tokens.length > 2 )
                {
                    result = "failure: too many tokens";
                }

                Stack<Integer> s = (st==1) ? s1 : s2;

                if( tokens[0].equals( "push" ) )
                {
                    if( d.size()==0 )
                    {
                        result = "failure: deck empty";
                        break;
                    }
                    else
                    {
                        s.add( d.poll() );
                    }
                }
                else if( tokens[0].equals( "pop" ) )
                {
                    if( s.size()==0 )
                    {
                        result = "failure: stack empty";
                        break;
                    }
                    else if( s.peek() < discard )
                    {
                        result = "failure: out of order";
                        break;
                    }
                    else
                    {
                        discard = s.pop();
                    }
                }
                else
                {
                    result = "failure: not a push or pop: " + tokens[0] ;
                    break;
                }
            }

            if( result.equals( "success" ) )
            {
                if( d.size() > 0 )
                {
                    result = "failure: deck not emptied";
                }
                else if( s1.size() > 0)
                {
                    result = "failure: s1 not emptied";
                }
                else if( s2.size() > 0)
                {
                    result = "failure: s2 not emptied";
                }
            }
            //System.out.println( "Case " + caseno + " " + which + " result: " + result );
        }
        return result;
    }

    public void doit() throws Exception
    {
        br = new BufferedReader( new FileReader( "stacks.in" ) );
        // br = new BufferedReader( new InputStreamReader( System.in ) );
        // ps = new PrintStream( new FileOutputStream( "checkstacks.sol" ) );
        // ps = System.out;

        BufferedReader out = new BufferedReader( new FileReader( "stacks.out" ) );
        BufferedReader sol = new BufferedReader( new FileReader( "stacks.sol" ) );
        int i, j, k;
        String tokens[];

        int nsets = 0;

        for(;;)
        {
            n = Integer.parseInt( br.readLine().trim() );
            if( n==0 ) break;

            ++nsets;

            deck = new Integer[n];
            tokens = br.readLine().trim().split( "\\s+" );
            for( i=0; i<n; i++ )
            {
                deck[n-i-1] = new Integer( tokens[i] );
            }

            String r1 = validate( out, "#" + nsets );
            String r2 = validate( sol, "#" + nsets );
            if( r1.equals(r2) )
            {
                //System.out.println( "Case #" + nsets + " is OK" );
            }
            else
            {
                System.out.println( "Case #" + nsets + " fails! out=" + r1 + ", sol=" + r2 );
                break;
            }
        }

        if( n==0 )
        {
            System.out.println( "All cases OK!" );
        }
    }

    public static void main( String args[] ) throws Exception
    {
        (new checkstacks()).doit();
    }
};
