import java.io.*;
import java.util.*;
import java.text.*;

public class cut
{
    public BufferedReader br;
    public PrintStream ps;

    public String toString()
    {
        return "cut";
    }

    class Cut implements Comparable
    {
        public int x1, y1, x2, y2, topx, topy, botx, boty;

        public Cut( int tx, int ty, int bx, int by )
        {
            x1=y1=x2=y2=0;
            topx = tx;
            topy = ty;
            botx = bx;
            boty = by;
        }

        public String toString()
        {
            return "{Cut:x1=" + x1 + ",y1=" + y1 + ",x2=" + x2 + ",y2=" + y2 
                + ",topx=" + topx + ",topy=" + topy + ",botx=" + botx + ",boty=" + boty + "}";
        }

        public int compareTo( Object o )
        {
            Cut c =(Cut)o;

            int diff = x1-c.x1;
            if( diff==0 ) diff = y1-c.y1;

            return diff;
        }
    };

    class Pane
    {
        public int topx, topy, botx, boty;

        public Pane( int tx, int ty, int bx, int by )
        {
            topx = tx;
            topy = ty;
            botx = bx;
            boty = by;
        }

        public String toString()
        {
            return "{Pane:topx=" + topx + ",topy=" + topy + ",botx=" + botx + ",boty=" + boty + "}";
        }
    };

    public TreeSet<Integer> xs, ys;
    public LinkedList<Pane> panes;

    public Cut bestcut( int topx, int topy, int botx, int boty )
    {
        Cut cut = null;

        for( int y : ys )
        {
            if( cut!=null ) break;
            if( y>topy && y<boty )
            {
                boolean success = true;
                for( Pane p : panes )
                {
                    if( y>p.topy && y<p.boty && topx<p.botx && botx>p.topx )
                    {
                        success = false;
                        break;
                    }
                }

                if( success )
                {
                    cut = new Cut( topx, topy, botx, boty );
                    cut.x1 = topx;
                    cut.y1 = y;
                    cut.x2 = botx;
                    cut.y2 = y;
                }
            }
        }

        for( int x : xs )
        {
            if( cut!=null ) break;
            if( x>topx && x<botx )
            {
                boolean success = true;
                for( Pane p : panes )
                {
                    if( x>p.topx && x<p.botx && topy<p.boty && boty>p.topy )
                    {
                        success = false;
                        break;
                    }
                }

                if( success )
                {
                    cut = new Cut( topx, topy, botx, boty );
                    cut.x1 = x;
                    cut.y1 = topy;
                    cut.x2 = x;
                    cut.y2 = boty;
                }
            }
        }

        return cut;
    }

    public void doit() throws Exception
    {
        br = new BufferedReader( new FileReader( "cut.in" ) );
        // br = new BufferedReader( new InputStreamReader( System.in ) );
        ps = new PrintStream( new FileOutputStream( "cut.sol" ) );
        // ps = System.out;
        int i, j, k;
        String tokens[];

        for(;;)
        {
            int n = Integer.parseInt( br.readLine().trim() );
            if( n==0 ) break;

            System.out.println( "n=" + n );

            int xmax = Integer.MIN_VALUE;
            int xmin = Integer.MAX_VALUE;
            int ymax = Integer.MIN_VALUE;
            int ymin = Integer.MAX_VALUE;

            xs = new TreeSet<Integer>();
            ys = new TreeSet<Integer>();
            panes = new LinkedList<Pane>();

            for( i=0; i<n; i++ )
            {
                tokens = br.readLine().trim().split( "\\s+" );
                int x1 = Integer.parseInt( tokens[0] );
                int y1 = Integer.parseInt( tokens[1] );
                int x2 = Integer.parseInt( tokens[2] );
                int y2 = Integer.parseInt( tokens[3] );

                if( x1<xmin ) xmin=x1;
                if( x2>xmax ) xmax=x2;
                if( y1<ymin ) ymin=y1;
                if( y2>ymax ) ymax=y2;

                xs.add( x1 );
                xs.add( x2 );
                ys.add( y1 );
                ys.add( y2 );

                panes.add( new Pane( x1, y1, x2, y2 ) );
            }

            PriorityQueue<Cut> q = new PriorityQueue<Cut>();
            q.add( bestcut( xmin, ymin, xmax, ymax ) );
            while( q.size() > 0 )
            {
                Cut c = q.poll();
                ps.println( "" + c.x1 + " " + c.y1 + " " +c.x2 + " " + c.y2 );

                Cut newc;
                newc = bestcut( c.topx, c.topy, c.x2, c.y2 );
                if( newc!=null ) q.add( newc );
                newc = bestcut( c.x1, c.y1, c.botx, c.boty );
                if( newc!=null ) q.add( newc );
            }
            ps.println();
        }
    }

    public static void main( String args[] ) throws Exception
    {
        (new cut()).doit();
    }
};
