import java.io.*;
import java.util.*;
import java.text.*;
import java.awt.*;

public class oyster
{
    public BufferedReader br;
    public PrintStream ps;

    public class Cell
    {
        public int left, right, below, above;
        boolean visited;

        public Cell()
        {
            reset();
        }

        public void reset()
        {
            left = right = below = above = 0;
            visited = false;
        }

        public String toString()
        {
            return "{Cell:left=" + left + ",right=" + right + ",below=" + below + ",above=" + above + "}";
        }
    };

    public Cell field[][] = new Cell[1004][1004];
    public int area, floodlevel;

    public String toString()
    {
        return "oyster";
    }

    public void doit() throws Exception
    {
        br = new BufferedReader( new FileReader( "oyster.in" ) );
        // br = new BufferedReader( new InputStreamReader( System.in ) );
        ps = new PrintStream( new FileOutputStream( "oyster.sol" ) );
        // ps = System.out;
        int i, j, k;
        String tokens[];

        for( i=0; i<1004; i++ ) for( j=0; j<1004; j++ )
        {
            field[i][j] = new Cell();
        }

        int ncases=0;

        for(;;)
        {
            int n = Integer.parseInt( br.readLine().trim() );
            if( n==0 ) break;

            ++ncases;

            for( i=0; i<1004; i++ )for( j=0; j<1004; j++ )
            {
                field[i][j].reset();
            }

            for( i=0; i<1004; i++ )
            {
                field[i][0].left = 2000;
                field[i][1003].right = 2000;
                field[0][i].above = 2000;
                field[1003][i].below = 2000;
            }

            for( k=0; k<n; k++ )
            {
                tokens = br.readLine().trim().split( "\\s+" );
                int i1 = Integer.parseInt( tokens[0] );
                int j1 = Integer.parseInt( tokens[1] );
                int i2 = Integer.parseInt( tokens[2] );
                int j2 = Integer.parseInt( tokens[3] );
                int h = Integer.parseInt( tokens[4] );

                if( i1==i2 ) // Horizontal
                {
                    i = i1+501;
                    if( j2<j1 )
                    {
                        int t=j1; j1=j2; j2=t;
                    }
                    j1+=501;
                    j2+=501;

                    for( j=j1; j<j2; j++ )
                    {
                        if( h>field[i-1][j].below ) field[i-1][j].below = h;
                        if( h>field[i][j].above) field[i][j].above = h;
                    }
                }
                else if( j1==j2 ) // Vertical
                {
                    j = j1+501;
                    if( i2<i1 )
                    {
                        int t=i1; i1=i2; i2=t;
                    }
                    i1+=501;
                    i2+=501;

                    for( i=i1; i<i2; i++ )
                    {
                        if( h>field[i][j-1].right ) field[i][j-1].right = h;
                        if( h>field[i][j].left ) field[i][j].left = h;
                    }
                }
                else
                {
                    System.out.println( "NOT horizontal or vertical!!" );
                }
            }

            floodlevel = Integer.parseInt( br.readLine().trim() );

            area = 1004*1004;

            LinkedList<Point> q = new LinkedList<Point>();
            q.add( new Point( 0, 0 ) );
            while( q.size()>0 )
            {
                Point p = q.remove();
                i = p.x; j = p.y;
                Cell cell = field[i][j];

                if( !cell.visited )
                {
                    --area;
                    cell.visited = true;
                    if( cell.left<floodlevel ) q.add( new Point( i, j-1 ) );
                    if( cell.right<floodlevel ) q.add( new Point( i, j+1 ) );
                    if( cell.above<floodlevel ) q.add( new Point( i-1, j ) );
                    if( cell.below<floodlevel ) q.add( new Point( i+1, j ) );
                }
            }

            ps.println( area );
        }
    }

    public static void main( String args[] ) throws Exception
    {
        (new oyster()).doit();
    }
};
