import java.io.*;
import java.util.*;
import java.text.*;

public class tax
{
    public BufferedReader br;
    public PrintStream ps;

    public int n;
    public double f;
    public int x[];
    public int areas[][];
    public double costs[][];

    public String toString()
    {
        return "tax";
    }

    public double findcost( int a, int b )
    {
        int i, j;
        if( costs[a][b] < -0.01 )
        {
            double mincost = Double.MAX_VALUE;

            // split [a..i], [i+1..b]
            for( i=a; i!=b; i=(i+1)%n )
            {
                double cost = findcost( a, i ) + findcost( (i+1)%n, b );
                cost += f*Math.max( areas[a][i], areas[(i+1)%n][b] );
                if( cost < mincost ) mincost = cost;
            }

            costs[a][b] = mincost;
        }

        return costs[a][b];
    }

    public void doit() throws Exception
    {
        br = new BufferedReader( new FileReader( "tax.in" ) );
        // br = new BufferedReader( new InputStreamReader( System.in ) );
        ps = new PrintStream( new FileOutputStream( "tax.sol" ) );
        // ps = System.out;
        int i, j, k;
        String tokens[];

        for(;;)
        {
            tokens = br.readLine().trim().split( "\\s+" );
            n = Integer.parseInt( tokens[0] );
            f = Double.parseDouble( tokens[1] );
            if( n==0 ) break;

            x = new int[n];
            tokens = br.readLine().trim().split( "\\s+" );
            for( i=0; i<n; i++ )
            {
                x[i] = Integer.parseInt( tokens[i] );
            }

            areas = new int[n][n];

            for( i=0; i<n; i++ )
            {
                areas[i][i] = x[i];
                for( j=1; j<n; j++ )
                {
                    k = (i+j)%n;
                    areas[i][k] = areas[i][(k-1+n)%n] + x[k]; 
                }
            }

            costs = new double[n][n];
            for( i=0; i<n; i++ )
            {
                Arrays.fill( costs[i], -1.0 );
                costs[i][i] = 0.0;
            }

            double mincost = n>1 ? Double.MAX_VALUE : 0.0;
            for( i=0; i<n; i++ ) for( j=0; j<n; j++ )
            {
                double cost = findcost( i, j ) + findcost( (j+1)%n, (i-1+n)%n );
                cost += f*Math.max( areas[i][j], areas[(j+1)%n][(i-1+n)%n] );
                if( cost<mincost ) mincost = cost;
            }

            ps.printf( "%.2f\n", mincost );
            System.out.printf( "%.2f\n", mincost );
        }
    }

    public static void main( String args[] ) throws Exception
    {
        (new tax()).doit();
    }
};
